# Aliens on My Lawn
# Copyright (C) 2009 Jeffrey Armstrong (a.k.a. PrintStar)
# http://jeff.rainbow-100.com/
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# 
# A full version of the license terms is available in LICENSE.

from math import floor
from pygame import *
from constants import *
from utilities import grid2xy
from data import load_image

class Bullet(sprite.Sprite):
    def __init__(self,velocity=10):
        sprite.Sprite.__init__(self)
        self.base_velocity = velocity
        
        self.velocity = [0,0]
        
    def invalid(self):
        return (self.rect.center[0] < 0 or self.rect.center[0] > GRID_X*GRID_WIDTH or \
                self.rect.center[1] > GRID_Y*(GRID_HEIGHT+1) or self.rect.center[1] < GRID_Y)        
        
    def north(self):
        self.velocity = [0,-1*self.base_velocity]
    
    def south(self):
        self.velocity = [0,self.base_velocity]
    
    def east(self):
        self.velocity = [self.base_velocity,0]
    
    def west(self):
        self.velocity = [-1*self.base_velocity,0]
    
    def direction(self,direction):
        if direction == NORTH:
            self.north()
        elif direction == SOUTH:
            self.south()
        elif direction == EAST:
            self.east()
        elif direction == WEST:
            self.west()
            
        
    def update(self):
        self.rect.left = self.rect.left + self.velocity[0]
        self.rect.top = self.rect.top + self.velocity[1]
        
class ShotgunShell(Bullet):
    def __init__(self):
        Bullet.__init__(self)
        
        self.rect = Rect(0,0,10,10)
        self.generate_image()
        
    def generate_image(self):
        # Simple surface creation
        self.image = Surface((self.rect.width,self.rect.height))
        self.image.convert()
        self.image.set_colorkey(Color('white'))
        self.image.fill(Color('white'))
        
        # Just a black circle
        draw.circle(self.image,Color('black'),self.rect.center,int(floor(self.rect.width/2)))
        
class AmmoSource(sprite.Sprite):
    def __init__(self):
        sprite.Sprite.__init__(self)     
        self.rect = Rect(grid2xy(PLAYER_GRID_START),(GRID_X,GRID_Y))
        self.image = load_image('ammo.png')
        