# Aliens on My Lawn
# Copyright (C) 2009 Jeffrey Armstrong (a.k.a. PrintStar)
# http://jeff.rainbow-100.com/
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# 
# A full version of the license terms is available in LICENSE.

import pygame
from data import filepath

class GameSound:
    def __init__(self,sound=True):
        self.sound = sound
        try:
            self.choice_sound = pygame.mixer.Sound(filepath('crash02.ogg'))
            self.shot_sound = pygame.mixer.Sound(filepath('explode01.ogg'))
            self.dead_sound = pygame.mixer.Sound(filepath('man.ogg'))
            self.pop_sound = pygame.mixer.Sound(filepath('pop.ogg'))
        except AttributeError:
            pass
        
    def menu(self):
        if self.sound:
            pygame.mixer.music.stop()
            pygame.mixer.music.load(filepath('menu.ogg'))
            pygame.mixer.music.play(-1)
            
    def shot(self):
        if self.sound:
            self.shot_sound.play()
    
    def pop(self):
        if self.sound:
            self.pop_sound.play()
    
    def choice(self):
        if self.sound:
            self.choice_sound.play()
            
            
            
    def killed(self):
        if self.sound:
            self.dead_sound.play()