# Aliens on My Lawn
# Copyright (C) 2009 Jeffrey Armstrong (a.k.a. PrintStar)
# http://jeff.rainbow-100.com/
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# 
# A full version of the license terms is available in LICENSE.

from constants import *
import random

def grid2xy(gp):
    """Returns the top-left corner grid point"""
    
    return (gp[0]*GRID_X,SCR_HEIGHT-(gp[1]+1)*GRID_Y)

def random_grid(not_edge=True):
    if not_edge:
        return (random.randint(1,GRID_WIDTH-2),random.randint(1,GRID_HEIGHT-2))
    else:
        return (random.randint(0,GRID_WIDTH-1),random.randint(0,GRID_HEIGHT-1))

def at_edge(sprite):
    if sprite.rect.center[0] <= 0:
        return WEST
    elif sprite.rect.center[1] <= GRID_Y:
        return NORTH
    elif sprite.rect.center[0] >= GRID_X*GRID_WIDTH:
        return EAST
    elif sprite.rect.center[1] >= (GRID_HEIGHT+1)*GRID_Y:
        return SOUTH
    
    return -1

def opposite_dir(direction):
    if direction == NORTH:
        return SOUTH
    elif direction == SOUTH:
        return NORTH
    elif direction == EAST:
        return WEST
    elif direction == WEST:
        return EAST
    return direction

def new_quad_player(sprite,moveto):
    center = sprite.rect.center
    if moveto == NORTH:
        sprite.rect.center = (sprite.rect.center[0],(GRID_HEIGHT+1)*GRID_Y-1)
    elif moveto == SOUTH:
        sprite.rect.center = (sprite.rect.center[0],GRID_Y+1)
    elif moveto == EAST:
        sprite.rect.center = (1,sprite.rect.center[1])
    elif moveto == WEST:
        sprite.rect.center = (GRID_X*GRID_WIDTH-1,sprite.rect.center[1])
        